/************************************************************************
 * 
 * CPS Player v0.2          / 27-dec-2004.   (PC version :-)
 * Coded by S.T.A.S.        mailto: s_t_a_s_@mail.ru
 * 
 ************************************************************************
 */ 

// Sound engine
#include "ay_emulator.cpp"

#include "music/music_i.cpp"
#include "music/music7.cpp"
#include "music/music9.cpp"
#include "music/music10.cpp"
#include "music/music12.cpp"
#include "music/music13.cpp"
#include "music/music15.cpp"
#include "music/music16.cpp"
#include "music/music19.cpp"
#include "music/music20.cpp"
#include "music/music21.cpp"



class   cps_player : public ay_emulator
{
public:

inline cps_player() : ay_emulator()
{}


void inline
initialize(HWND window_handle, const int priority = THREAD_PRIORITY_TIME_CRITICAL)   
{
    unsigned long dummy_ID;
    if( ! ay_emulator::initialize(window_handle) )
    {
        thread = CreateThread(0, 0, play, this, 0, &dummy_ID);
        SetThreadPriority(thread, priority);
    }
}

void kill()
{
    safe_terminate_thread(thread);
    ay_emulator::kill();
}

void static inline choose(unsigned char n)
{
    music_number = n;
}

private:

static unsigned long __stdcall
play(void * p);


    void              * thread;

    typedef struct{
        void          * data;
        float           fq_base;
    }   cpsc;

    static unsigned char    music_number;
    static cpsc         music[];
};


#define BASE_FQ_J_CUSTOM    ZX_AY_frequency / 16 / 24.37997
#define BASE_FQ_STRACKER    ZX_AY_frequency / 16 / 27.5 // = 440 / pow(2, (48/12))                
#define BASE_FQ_STANDARD    0

short base_fq_cps_standard[12] = 
{
    0xEF8, 0xE10, 0xD60, 0xC80, 0xBD8, 0xB28,
    0xA88, 0x9F0, 0x960, 0x8E0, 0x858, 0x7E0
};

cps_player::cpsc    cps_player::music[] = 
{
    music_i-48, BASE_FQ_STANDARD,
    music7-48,  BASE_FQ_J_CUSTOM,// 1
    music9-48,  BASE_FQ_J_CUSTOM,// 2
    music10-48, BASE_FQ_STANDARD,// 3
    music12-48, BASE_FQ_STANDARD,// 4
    music13-48, BASE_FQ_STRACKER,// 5
    music15-48, BASE_FQ_STRACKER,// 6
    music16-48, BASE_FQ_STANDARD,// 7
    music19-48, BASE_FQ_STANDARD,// 8
    music20-48, BASE_FQ_STANDARD,// 9
    music21-48, BASE_FQ_STRACKER // 0
};

#undef  BASE_FQ_STANDARD
#undef  BASE_FQ_J_CUSTOM               
#undef  BASE_FQ_STRACKER

unsigned char   cps_player::music_number;


unsigned long __stdcall
cps_player::play(void * p)
{
    cps_player   * This = (cps_player *)p;
//    SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);

#pragma pack(push)
#pragma pack(1)

typedef struct
{   //   
    char                signature   [0x10];
    unsigned char       title_strlen;           // 0x10
    char                title       [0x0F];
    unsigned char       author_srtlen;          // 0x20
    char                author      [0x0F];
    // 
    unsigned char       loop_position;          // 0x30
    unsigned char       nomber_of_positions;	// 0x31
    unsigned char       mode;                   // 0x32  
    unsigned short      loop_offset;            // 0x33
    unsigned short      pattern_table_offset;   // 0x35
    unsigned short      sample_table_offset;    // 0x37
    unsigned char       number_of_patterns;     // 0x39  
    unsigned char       element     [0];        // 0x3A
}   CPS_compose;

typedef struct {
    unsigned char       length;                 // 0x00
    unsigned short      envelope_data_offset;   // 0x01..0x02
    unsigned short      channel_offset  [AY_channels];
}   CPS_pattern;

typedef struct {
    unsigned char       length;                 //..0x00
    unsigned short      loop_offset;            //..0x01..0x02
    unsigned char       repeat;                 //..0x03
    unsigned char       data        [1/**/];    //..0x04
}   CPS_sample;

typedef struct {
    unsigned char       length;                 //..0x00
    unsigned char       loop;                   //..0x01
    unsigned char       repeat;                 //..0x02
    unsigned char       line        [1/**/];    //..0x03
}   CPS_ornament;

#pragma pack(pop)

typedef struct {
    unsigned            patern_data;
    unsigned            sample_loop;
    unsigned            sample_line;
    unsigned char       repeat;
    unsigned char       note;
    unsigned char       so;
    unsigned char       quark;
    unsigned char       sample_length;
    unsigned char       sample_repeat;
    unsigned char       orn_length;
    unsigned char       orn_loop;
    unsigned char       orn_repeat;
    unsigned char       orn_line;
    unsigned char       tone_displ;
}   AY_channel;


    #define	GET_ADDRESS(X)  ((unsigned)(X)+(unsigned)compose)

    unsigned            fq_divisor [96+1];
    static float        fq_step = 1.05946309435929526;  // = pow(2, (1/12))
    CPS_compose       * compose;

change_music:
    __asm
    {
await:  push    2
        call    dword ptr Sleep
        mov     ecx, offset music_number
        movzx   eax, byte ptr[ecx]
        dec     eax
        js      await
        mov     byte ptr[ecx], 0
        fninit
        xor     ecx, ecx
        lea     eax, music[eax * size cpsc]
        push    [eax]cpsc.data
        pop     compose
        cmp     [eax]cpsc.fq_base, ecx  // BASE_FQ_STANDARD
        jnz     compute_fq
        lea     edx, fq_divisor
octave: xor     eax, eax
semitone:
        push    eax
        movzx   eax, word ptr base_fq_cps_standard[eax*2]
        shr     eax, cl
        mov     dword ptr[edx], eax
        add     edx, 4
        pop     eax
        inc     eax
        cmp     al, 12
        jb      semitone
        inc     ecx
        cmp     ecx, 8
        jb      octave
        and     dword ptr[edx], 0
        jmp     done
compute_fq:
        fld1
    l:  fld     [eax]cpsc.fq_base
        fdiv    st(0), st(1)
        fistp   dword ptr fq_divisor[ecx*4]
        fmul    fq_step
        inc     ecx
        cmp     ecx, 96
        jbe     l
done:
    }
//    compose=(CPS_compose *)music[music_number].data;
//    music_number = 0;

    unsigned char     * element = &compose->element[0];
    unsigned            current_position = 0;

play_music:
    AY_channel      channel [AY_channels];
    unsigned        envelope_data_offset;
    unsigned        envelope_frequency = 0;
    unsigned        delay;
    if( current_position >= compose->nomber_of_positions )
    {
        current_position = compose->loop_position;
        element = &compose->element[compose->loop_offset
                -((unsigned)&(compose->element[0])-(unsigned)compose)];
    }			
    if( *element & 1<<6 )
        delay = *element++ & 0x3F;

    CPS_pattern   * pattern = (CPS_pattern *)
            GET_ADDRESS(compose->pattern_table_offset) + (*element & 0x7F);

    channel[channel_A].patern_data = pattern->channel_offset[channel_A];
    channel[channel_B].patern_data = pattern->channel_offset[channel_B];
    channel[channel_C].patern_data = pattern->channel_offset[channel_C];
    envelope_data_offset = pattern->envelope_data_offset;
    channel[channel_A].repeat = channel[channel_B].repeat =
    channel[channel_C].repeat = 1;
    unsigned char   envelope_repeat = 1;

    if( *element & 1<<7 )
    {
        channel[channel_A].tone_displ = *(++element);
        channel[channel_B].tone_displ = *(++element);
        channel[channel_C].tone_displ = *(++element);
    }
    else
    {
        channel[channel_A].tone_displ = channel[channel_B].tone_displ =
        channel[channel_C].tone_displ = 0;
    }
    element++;
    current_position++;

    for( unsigned char line = 0; line <= pattern->length; line++ )
    {
        if( music_number ) goto change_music;
        CPS_sample    * sample      [AY_channels];
        CPS_ornament  * ornament    [AY_channels];
        if( !(--envelope_repeat) )
        {
            if( *(unsigned char *)GET_ADDRESS(envelope_data_offset) )
                envelope_frequency = *(unsigned char *)
                                   GET_ADDRESS(envelope_data_offset++),
                envelope_repeat = 1;
            else
                envelope_data_offset++,
                envelope_repeat = *(unsigned char *)
                                GET_ADDRESS(envelope_data_offset++);
        }
        for(int cn = channel_C; cn >= channel_A; cn--)
        {
            if( !(--channel[cn].repeat) )
            {
                unsigned char el = *(unsigned char *)
                                GET_ADDRESS(channel[cn].patern_data++);
			
                if( (el & 0x7f) >= 96 )	// don't generate new note, play previous
                    channel[cn].repeat = el < 0x80 ? el - 95 
                                                   : el - 95 - 96;
                else
                {
                    channel[cn].note   = el & 0x7F;
                    channel[cn].repeat = 1;
                    channel[cn].quark  = -1;
				
                    if( el >= 0x80 )
                    {
                        unsigned char so;	// temp Sample & Ornament byte
                        if( !(so = *(unsigned char *)
                                    GET_ADDRESS(channel[cn].patern_data++)) )
                            channel[cn].note = 0xFF;
                        if( so & 0x0F )
                            channel[cn].so = (channel[cn].so&0xF0) | (so&0x0F);
                        if( so & 0xF0 )
                            channel[cn].so = (channel[cn].so&0x0F) | (so&0xF0);					
                    }                
                    short * instruments = (short *)
                            GET_ADDRESS(compose->sample_table_offset);
                    sample[cn] = (CPS_sample*)GET_ADDRESS(
                            *(instruments + (channel[cn].so >> 4)));
                    channel[cn].sample_length = sample[cn]->length;
                    channel[cn].sample_loop = sample[cn]->loop_offset;
                    channel[cn].sample_repeat = sample[cn]->repeat;
                    channel[cn].sample_line = (unsigned)&(sample[cn]->data);
                    if( ornament[cn] = (CPS_ornament *)GET_ADDRESS(
                            *(instruments + 16 +(channel[cn].so & 0xF))) )
                    {
                        channel[cn].orn_length = ornament[cn]->length;
                        channel[cn].orn_loop   = ornament[cn]->loop;
                        channel[cn].orn_repeat = ornament[cn]->repeat;
                        channel[cn].orn_line   = 0;
                    }
                }
            }
        }
        for( unsigned i=0; i < delay; i++ )
        {
            for( int cn = channel_C; cn >= channel_A; cn-- )
            {
                This->tone_mask[cn] = 0;
                This->noise_mask[cn] = -1;
                if( channel[cn].note >= 0x80 )
                {
                    This->tone_volume[cn] = 0;
                    This->tone_mask[cn] = -1;
                }
                else
                {
                    unsigned char note = 0x7F & ( channel[cn].note
                                    + channel[cn].tone_displ
                                    + ornament[cn]->line[channel[cn].orn_line] );
                    if( note > 96 )
                        note = 97;
                    unsigned short voltone = *(unsigned short *)
                                                    channel[cn].sample_line;
                    channel[cn].sample_line += 2;

                    This->tone_frequency[cn] = 0xFFF & fq_divisor[note] + voltone;
                    if( (voltone & 0xFFF) == 0x7FF )
                    {
                        This->tone_mask[cn] = -1;
                        This->tone_frequency[cn] = 0;
                    }
                    if( (voltone & 0xFFF) == 0x800 )
                        This->tone_frequency[cn] = 0;

                    char noise = *(char *)channel[cn].sample_line++;
                    if( noise & 1<<6 )
                    {
                        if( unsigned envelope_mode = voltone >> 8+4 )
                        {
                            This->envelope_mode = envelope_mode;
                            This->envelope_cycle = 0;
                            This->envelope_volume = 0,
                            This->envelope_add = 1;     // attack
                            if( ! (envelope_mode & 4) )
                            {
                                This->envelope_volume += 31;
                                This->envelope_add = -This->envelope_add;   // decay
                            }
                        }
                        This->tone_volume[cn] = 0x10;
                        if( noise & 1<<7 )
                        {
                            channel[cn].sample_line++;
                            if( envelope_frequency )
                                This->envelope_frequency = *(char *)
                                    (channel[cn].sample_line-1) + envelope_frequency;
                        }
                        else if( envelope_frequency )
                            This->envelope_frequency = envelope_frequency;
                    }
                    else
                        This->tone_volume[cn] = voltone >> 8+4;

                    if( noise & 1<<5 )
                    {
                        This->noise_frequency = (noise & 0x1F) * 2;
                        This->noise_mask[cn] = 0;
                    }
                    if( channel[cn].sample_length <= (++channel[cn].quark) )
                    {
                        channel[cn].quark         = 0;
                        channel[cn].sample_length = channel[cn].sample_repeat;
                        channel[cn].sample_line = GET_ADDRESS(channel[cn].sample_loop);
                    }
                    if( channel[cn].orn_line >= channel[cn].orn_length )
                    {
                        channel[cn].orn_length = channel[cn].orn_repeat;
                        channel[cn].orn_line = channel[cn].orn_loop;
                    }
                    channel[cn].orn_line++;
                }
            }// for( channel )
            This->flush_sound();
            This->do_sound();
        }// for( i < delay )
    }// for( line )
goto play_music;
#undef	GET_ADDRESS
}

// EOF
