/************************************************************************
 * 
 ************************************************************************
 */ 


// 8*5 font -     'Z' .
//     7*5,     8 :
//     0.
#include "font/font8x5.cpp"

namespace   font8x5
{
#pragma optimize( "O2t", on )       //   align

//       .
// 4x  ,   5x
__declspec(naked) ARGB * __fastcall
draw_char_X4H(
            ARGB          * memory, // ecx
            long            pitch,  // edx
            char            ascii,  // [esp+4]
            ARGB            color   // [esp+8]
            )
{
    __asm
    {
        movzx   eax, byte ptr[esp+4]    ;// &data[ascii-' '][0]
        cmp     al, '\n'
        jz      LF
        sub     al, ' '
        jc      quit                    ;//  
        jz      space
        pushad
        mov     ebp, [esp+8][8*4]
        lea     ebx, [edx+2*edx]        ;// 3  :
        add     ecx, ebx                ;//   24 .
        and     ebp, 0FEFEFFh   ;//        !! 
        lea     esi, data[eax*4+eax]    ;// HARDCODED: columns = 5
        mov     eax, columns*10000h     ;//  .
Y:      mov     ah, 7                   ;//  .
        lods    byte ptr esi            ;//   :
X:      xor     ebx, ebx                ;//   76543210
        add     al, al                  ;//   XXXXXXX0      <<  
        setnc   bl                      ;//  (X -  )
        dec     ebx                     ;//  6   1, 
        and     ebx, ebp                ;// ebx = color,  0.
        ;// ""     4*4 
        or      [ecx][1*edx][0*4], ebx  ;// 1- 
        or      [ecx][1*edx][1*4], ebx
        or      [ecx][1*edx][2*4], ebx
        or      [ecx][1*edx][3*4], ebx
        or      [ecx][2*edx][0*4], ebx  ;// 2- 
        or      [ecx][2*edx][1*4], ebx
        or      [ecx][2*edx][2*4], ebx
        or      [ecx][2*edx][3*4], ebx
        shr     ebx, 1
        add     ecx, edx                ;// 3- 
        and     ebx, 0x7F7F7F
        or      [ecx][2*edx][0*4], ebx
        or      [ecx][2*edx][1*4], ebx
        or      [ecx][2*edx][2*4], ebx
        or      [ecx][2*edx][3*4], ebx
        sub     ecx, edx
        ;// LOL!!! MSVC (cl.exe 13.10)   !!!
        ;// or [ecx][0*edx], ebx == or [ecx][1*edx], ebx :-/
        or      [ecx][0*4], ebx         ;// 0- 
        or      [ecx][1*4], ebx
        or      [ecx][2*4], ebx
        or      [ecx][3*4], ebx
        ;//  ""  
        add     ecx, 4*4
        dec     ah
        jnz     X
        ;//         
        lea     ecx, [ecx+4*edx-4*4*7]
        ;//  ""     
        add     ecx, edx
        sub     eax, 10000h             ;// silly HACK: ax == 0
        jnz     Y
        popad
space:  lea     eax, [ecx+4*4*8]
        ret     8
quit:   mov     eax, ecx
        ret     8
LF:     imul    edx, edx, 30
        lea     eax, [ecx + edx]
        ret     8        
    }
}


//       .
// 2x  ,  4x
__declspec(naked) ARGB * __fastcall
draw_char_X2H(
            ARGB          * memory, // ecx
            long            pitch,  // edx
            char            ascii,  // [esp+4]
            ARGB            color   // [esp+8]
            )
{
    __asm
    {
        movzx   eax, byte ptr[esp+4]    ;// &data[ascii-' '][0]
        cmp     al, '\n'
        jz      LF
        sub     al, ' '
        jc      quit                    ;//  
        jz      space
        pushad
        mov     ebp, [esp+8][8*4]
        lea     ebx, [edx+2*edx]        ;// 3  :
        add     ecx, ebx                ;//   24 .
        and     ebp, 0FEFEFFh   ;//        !! 
        lea     esi, data[eax*4+eax]    ;// HARDCODED: columns = 5
        mov     eax, columns*10000h     ;//  .
Y:      mov     ah, 7                   ;//  .
        lods    byte ptr esi            ;//   :
X:      xor     ebx, ebx                ;//   76543210
        add     al, al                  ;//   XXXXXXX0      <<  
        setnc   bl                      ;//  (X -  )
        dec     ebx                     ;//  6   1, 
        and     ebx, ebp                ;// ebx = color,  0.
        ;// ""     2*4 
        or      [ecx][1*edx][0*4], ebx  ;// 1- 
        or      [ecx][1*edx][1*4], ebx
        shr     ebx, 1
        and     ebx, 0x7F7F7F
        or      [ecx][2*edx][0*4], ebx  ;// 2- 
        or      [ecx][2*edx][1*4], ebx
        or      [ecx][0*4], ebx         ;// 0- 
        or      [ecx][1*4], ebx
        ;//  ""  
        add     ecx, 2*4
        dec     ah
        jnz     X
        ;//         
        ;//  ""     
        lea     ecx, [ecx+4*edx-2*4*7]
        sub     eax, 10000h             ;// silly HACK: ax == 0
        jnz     Y
        popad
space:  lea     eax, [ecx+2*4*8]
        ret     8
quit:   mov     eax, ecx
        ret     8
LF:     imul    edx, edx, 25
        lea     eax, [ecx + edx]
        ret     8        
    }
}

#pragma optimize( "", on )
}

