/************************************************************************
 * 
 ************************************************************************
 */ 


//    
#include "levels/levels.cpp"

//       
//      
//   -  
const vborder = 40;


//=========================================================================//
#include "gfx_draw_sprite.cpp"
#include "gfx_draw_hud.cpp"
#include "gfx_draw_room.cpp"


//=========================================================================//
//   
void __fastcall
show_scene(ARGB * memory, long pitch)
{
    draw_border(memory, pitch, -1);

    format_to_ascii(&score_text[score_position], score);
    draw_text((ARGB *)((char *)memory + 2*4*4*8 + 3 * pitch), 
                pitch, score_text, -1);

    format_to_ascii(&level_text[level_position], level);
    format_to_ascii(&level_text[lives_position], lives);
    draw_text((ARGB *)((char *)memory + 4*4*8/2 + 447 * pitch), 
                pitch, level_text, -1);

    draw_room(memory, pitch, &levels::data[level-1]);

    if( input_device::is_key_pressed(DIK_ESCAPE) 
        || level > 25 )
        select_root_menu();

    if( input_device::is_any_key_hit() )
        level++;
    
}


//=========================================================================//
//    ""
void __fastcall
start_game(ARGB * memory, long pitch)
{
    //  
    unsigned y = height;    ARGB * p = memory;
    do
    {
        ARGB color = qsin((Frame_step>>14)+y)>>26
            | 0x3f0000 & qsin(y-(Frame_step>>13)+sine_table_size/3)>>10;
        unsigned    x = width;
        do  p[--x] = color;
        while( x );
        p = (ARGB *)((char *)p + pitch);
    }
    while( --y );

    //  "" .
    draw_char = font8x5::draw_char_X2H;
    draw_text(
            (ARGB *)((char *)memory + 8*sizeof(ARGB) + 2*pitch), 
            pitch,
            "         EVIL XAKEP THE BHAAL\n"
            "    HAS CAPTURED ALL TAI CHI CRYSTALS\n"
            "       AND TRIES TO ENTOMB THEM.\n"
            "\n"
            "   THIS PROBABLY WILL RUIN THE BEING.\n"
            "\n"
            "             FORTUNATELLY,\n"
            "      FAIR ZEN-DO MASTER THE C0DE\n"
            "    IS HERE TO MAKE THE RESTITUTION.\n"
            "WITH THE HELP OF GODS & SOME NICE TRICK\n"
            "HE TRANSMITTED HIMSELF TO BHAAL'S LAIR.\n"
            "         BUT THERE'S A FLOOD\n"
            "   OF EVIL'S HENCHMANS ON HIS WAY...\n"
            "\n"
            "       DON'T BE A LAME SPECTATOR\n"
            "            OF THIS SCENE!\n"
            "  USE ARROW KEYS TO DIRECT THE RUNNER.\n"
            "  AND THERE'S CTRL KEY TO HACK AROUND.\n"
            "       GOOD LUCK, YOU'LL NEED IT!"
            , 
            0x00FF00
            );    
    draw_char = font8x5::draw_char_X4H;

    if( input_device::is_any_key_hit() )
    {
        cps_player::choose(9);
        gfx[0]  = show_scene;
        lives = 10, level = 1,  score = 0;
    }
}


