/************************************************************************
 * 
 *   
 * 
 ************************************************************************
 */ 


#include "pixel_format.h"

struct  character
{
    ARGB                color;
    void (__fastcall  * drawer[5])();
};

//=========================================================================//

#include "gfx_logo_characters.cpp"

//=========================================================================//


static character    code_runner[] = 
{
    {0, { draw_O2, draw_O3, draw_C1, draw_C4, 0 } },        // C
    {0, { draw_O2, draw_O3, draw_O1, draw_O4, 0 } },        // O
    {0, { draw_D2, draw_D3, draw_O1, draw_O4, 0 } },        // D
    {0, { draw_O2, draw_O3, draw_C1, draw_C4, draw_E0 } },  // E

    {0, { draw_O2, draw_U2, draw_O1, draw_R4, 0 } },        // R
    {0, { draw_U2, draw_O3, draw_U1, draw_O4, 0 } },        // U
    {0, { draw_O2, draw_U2, draw_O1, draw_U1, 0 } },        // N
    {0, { draw_O2, draw_U2, draw_O1, draw_U1, 0 } },        // N
    {0, { draw_O2, draw_O3, draw_C1, draw_C4, draw_E0 } },  // E
    {0, { draw_O2, draw_U2, draw_O1, draw_R4, 0 } }         // R
};


#pragma warning(push)
#pragma warning(disable: 4700)

void __fastcall
draw_logo(ARGB * memory, long pitch)
{
    SET_FPU_CONTROL_WORD(FPU_MASK_ALL_EXEPTIONS
                        |FPU_PRECISION_24
                        |FPU_ROUND_DOWN);
    
    const static  unsigned    min_char_size = 28;
    const static  unsigned    gap = min_char_size*2 - 6;

    unsigned step = 11 * *((unsigned short *)&Frame_step+1);    // >> 16

    long  * p = (long *)memory + width/2 + height/2/sizeof(long)*pitch;
    character * characters = code_runner;
    for( char l = 2; l <= 3; l++ )
    {
        for( signed char i = -l; i < l; i++ )
        {
            unsigned char_size = min_char_size + (qsin(i*(77+l*287)+step) >> 27);           
            if( !characters->color || char_size == min_char_size )
                characters->color = qrandom() & 0x808080;
            draw_character(p+(2*i+1)*gap-(6-l)*(char_size*pitch/4),
                pitch, char_size, characters++);
        }
        p = (long *)((char *)p + 2*gap*pitch);
    }

}
#pragma warning(pop)

// EOF
