/************************************************************************
 *     4 :
 *
 *      2|1
 *      -+-
 *      3|4
 *
 *     5- .
 *
 *  (__fastcall)     :
 *
 *      long * p,               // ecx      -  
 *      long            pitch,  // edx      -  
 *      unsigned        size    // [esp+4]  -   
 *                              // esi      - "" ;
 *
 *    SIZE.
 *     !!
 *  ( size)  .
 *
 ************************************************************************
 */ 



__declspec(naked) void __fastcall
draw_character(
        long * p,               // ecx
        long pitch,             // edx
        unsigned size,          // [esp+4]
        character * data        // [esp+8]
        )
{
    __asm
    {
        push    ebx
        push    ebp
        push    edi
        push    esi
        mov     edi, [esp][8][4*4]
        mov     esi, [edi]character.color
        mov     ebp, ecx
        call    [edi]character.drawer[0*4]
        call    [edi]character.drawer[1*4]
        mov     ecx, ebp
        call    [edi]character.drawer[2*4]
        call    [edi]character.drawer[3*4]
        mov     eax, [edi]character.drawer[4*4]
        test    eax, eax
        jz      skip5
        mov     ecx, ebp
        call    eax
    skip5:
        pop     esi
        pop     edi
        pop     ebp
        pop     ebx
        ret     8
    }
}


enum    { letter_proportion = 4, letter_proportion_sl = 2 };
static  float   letter_proportion2 = 1.0/letter_proportion/letter_proportion;

#pragma optimize( "O2t", on )       //   align

#define SIZE dword ptr[esp+4*4+4+4] //  push ebx, ebp, esi, edi  call !


//=========================================================================//
//  .

// "O" - 2 
__declspec(naked) void __fastcall
draw_O2(/* .  !! ^^ */)
{
    __asm
    {   
        // x: - sqrt(size*size - y*y) ... 0
        mov     ebx, SIZE
    Y1: fild    SIZE
        fmul    st(0), st(0)
        mov     [esp][-4], ebx
        fild    dword ptr[esp][-4]
        fmul    st(0), st(0)
        fsubp   st(1), st(0)
        fsqrt
        fistp   dword ptr [esp][-4]
        mov     eax, dword ptr [esp][-4]
        neg     eax
    X1: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        inc     eax
        js      X1
        mov     eax, ebx
        add     ecx, edx
        shl     eax, letter_proportion_sl
        dec     ebx
        cmp     SIZE, eax
        jc      Y1

        // x: - sqrt(size*size - y*y) ... - sqrt(size*size/K - y*y)
    Y2: push    ebx
        fild    dword ptr[esp]
        fmul    st(0), st(0)
        fild    SIZE[4]            // push ebx !
        fmul    st(0), st(0)        
        fld     st(0)               // size*size
        fsub    st(0), st(2)
        fsqrt
        fistp   dword ptr[esp]
        mov     eax, dword ptr[esp]
        neg     eax
        fmul    letter_proportion2
        fsubrp  st(1), st(0)
        fsqrt
        fchs
        fistp   dword ptr[esp]
    X2: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        cmp     dword ptr[esp], eax
        lea     eax, [eax+1]
        ja      X2
        add     esp, 4
        add     ecx, edx
        dec     ebx
        jnz     Y2
        ret
    }
}


// "O" - 3 
__declspec(naked) void __fastcall
draw_O3(/* .  !! ^^ */)
{
    __asm
    {   
        // x: - sqrt(size*size - y*y) ... - sqrt(size*size/K - y*y)
        xor     ebx, ebx
    Y2: mov     [esp][-4], ebx
        fild    dword ptr[esp][-4]
        fmul    st(0), st(0)
        fild    SIZE
        fmul    st(0), st(0)        
        fld     st(0)               // size*size
        fsub    st(0), st(2)
        fsqrt
        fistp   dword ptr [esp][-4]
        mov     eax, dword ptr [esp][-4]
        neg     eax
        fmul    letter_proportion2
        fsubrp  st(1), st(0)
        fsqrt
        fchs
        fistp   dword ptr [esp][-4]
    X2: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        cmp     dword ptr ss:[esp][-4], eax //    Y1
        lea     eax, [eax+1]
        jnz     X2
        inc     ebx
        mov     eax, ebx
        shl     eax, letter_proportion_sl
        add     ecx, edx
        cmp     SIZE, eax
        jnc     Y2

        // x: - sqrt(size*size - y*y) ... 0
    Y1: fild    SIZE
        fmul    st(0), st(0)
        mov     [esp][-4], ebx
        fild    dword ptr[esp][-4]
        fmul    st(0), st(0)
        fsubp   st(1), st(0)
        fsqrt
        fistp   dword ptr[esp][-4]
        mov     eax, ss:dword ptr[esp][-4]
        neg     eax
    X1: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        inc     eax
        js      X1
        inc     ebx
        add     ecx, edx
        cmp     SIZE, ebx
        ja      Y1
        ret
    }
}


// "O" - 1 
__declspec(naked) void __fastcall
draw_O1(/* .  !! ^^ */)
{
    __asm
    {
        // x: sqrt(size*size - y*y) ... 0
        mov     ebx, SIZE
    Y1: fild    SIZE
        fmul    st(0), st(0)
        mov     [esp][-4], ebx
        fild    dword ptr[esp][-4]
        fmul    st(0), st(0)
        fsubp   st(1), st(0)
        fsqrt
        fistp   dword ptr[esp][-4]
        mov     eax, dword ptr [esp][-4]
    X1: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        dec     eax
        jns     X1
        lea     eax, [ebx*letter_proportion]
        add     ecx, edx
        cmp     SIZE, eax
        dec     ebx
        jc      Y1
        
        // x: sqrt(size*size - y*y) ... sqrt(size*size/K - y*y)
    Y2: mov     [esp][-4], ebx
        fild    dword ptr[esp][-4]
        fmul    st(0), st(0)
        fild    SIZE
        fmul    st(0), st(0)        
        fld     st(0)               // size*size
        fsub    st(0), st(2)
        fsqrt
        fistp   dword ptr[esp][-4]
        mov     eax, dword ptr[esp][-4]
        fmul    letter_proportion2
        fsubrp  st(1), st(0)
        fsqrt
        fistp   dword ptr[esp][-4]
    X2: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        cmp     dword ptr[esp][-4], eax
        lea     eax, [eax-1]
        jc      X2
        add     ecx, edx
        dec     ebx
        jnz     Y2
        ret
    }
}


// "O" - 4 
__declspec(naked) void __fastcall
draw_O4(/* .  !! ^^ */)
{
    __asm
    {
        // x: sqrt(size*size - y*y) ... sqrt(size*size/K - y*y)
        xor     ebx, ebx
    Y2: mov     ss:[esp][-4], ebx
        fild    dword ptr[esp][-4]
        fmul    st(0), st(0)
        fild    SIZE
        fmul    st(0), st(0)        
        fld     st(0)               // size*size
        fsub    st(0), st(2)
        fsqrt
        fistp   dword ptr[esp][-4]
        mov     eax, dword ptr[esp][-4]
        fmul    letter_proportion2
        fsubrp  st(1), st(0)
        fsqrt
        fistp   ss:dword ptr[esp][-4]
    X2: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        cmp     dword ptr[esp][-4], eax
        dec     eax
        jc      X2
        add     ebx, 1
        lea     eax, [ebx*letter_proportion]
        add     ecx, edx
        cmp     ss:SIZE, eax
        jnc     Y2

        // x: sqrt(size*size - y*y) ... 0
    Y1: fild    ss:SIZE
        fmul    st(0), st(0)
        mov     ss:[esp][-4], ebx
        fild    ss:dword ptr[esp][-4]
        fmul    st(0), st(0)
        fsubp   st(1), st(0)
        fsqrt
        fistp   ss:dword ptr[esp][-4]
        mov     eax, dword ptr[esp][-4]
    X1: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        dec     eax
        jns     X1
        add     ecx, edx
        inc     ebx
        cmp     SIZE, ebx
        ja      Y1
        ret
    }
}


// "C" - 1 
__declspec(naked) void __fastcall
draw_C1(/* .  !! ^^ */)
{
    __asm
    {
        // x: size ... 0
        mov     ebx, SIZE
        shl     ebx, letter_proportion_sl
    Y:  mov     eax, SIZE
        add     ecx, edx
        sub     ebx, letter_proportion
    X:  shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        dec     eax
        jns     X
        cmp     SIZE, ebx
        jc      Y
        shr     ebx, letter_proportion_sl
        imul    ebx, edx
        add     ecx, ebx
        ret
    }
}


// "C" - 4 
__declspec(naked) void __fastcall
draw_C4(/* .  !! ^^ */)
{
    __asm
    {//int 3
        // x: size ... 0
        mov     ebx, SIZE
        mov     eax, ebx
        shr     eax, letter_proportion_sl
        imul    eax, edx
        shl     ebx, letter_proportion_sl
        add     ecx, eax
    Y:  mov     eax, SIZE
        add     ecx, edx
    X:  shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        dec     eax
        jns     X
        sub     ebx, letter_proportion
        cmp     SIZE, ebx
        jc      Y
        ret
    }
}


// "D" - 2 
__declspec(naked) void __fastcall
draw_D2(/* .  !! ^^ */)
{
    __asm
    {
        // x: size ... 0
        mov     ebx, SIZE
        shl     ebx, letter_proportion_sl
    Y1: mov     eax, SIZE
        neg     eax
        add     ecx, edx
        sub     ebx, letter_proportion
    X1: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        inc     eax
        js      X1
        cmp     SIZE, ebx
        jc      Y1
        
        // x: size ... size/letter_proportion
    Y2: mov     eax, SIZE
        neg     eax
        mov     [esp][-4], eax
        sar     eax, letter_proportion_sl
        add     ecx, edx
    X2: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        cmp     [esp][-4], eax
        dec     eax
        jc      X2
        sub     ebx, letter_proportion
        ja      Y2
        ret
    }
}


// "D" - 3 
__declspec(naked) void __fastcall
draw_D3(/* .  !! ^^ */)
{
    __asm
    {
        // x: size ... size/letter_proportion
        xor     ebx, ebx
    Y2: mov     eax, ss:SIZE                    //    Y1
        neg     eax
        mov     ss:[esp][-4], eax
        sar     eax, letter_proportion_sl
        add     ecx, edx
        inc     ebx
    X2: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        cmp     [esp][-4], eax
        dec     eax
        jc      X2
        lea     eax,[ebx*letter_proportion]
        cmp     ss:SIZE, eax
        ja      Y2

        // x: size ... 0
    Y1: mov     eax, SIZE
        neg     eax
        add     ecx, edx
    X1: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        inc     eax
        js      X1
        inc     ebx
        cmp     SIZE, ebx
        ja      Y1
        ret
    }
}


// "E" - 
__declspec(naked) void __fastcall
draw_E0(/* .  !! ^^ */)
{
    __asm
    {
        mov     eax, SIZE
        shr     ebx, letter_proportion_sl          
        mov     eax, SIZE
        shr     eax, letter_proportion_sl+1
        sub     eax, SIZE
        imul    eax, edx
        sub     ecx, eax
    Y:  add     ecx, edx
        mov     eax, SIZE
        lea     eax, [eax*2+eax]
        shr     eax, 2
    X:  shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        dec     eax
        jnz     X
        dec     ebx
        jnz     Y
        ret
    }
}


// "U" - 2 
__declspec(naked) void __fastcall
draw_U2(/* .  !! ^^ */)
{
    __asm
    {
        // x: size ... size/letter_proportion
        mov     ebx, SIZE
    Y:  mov     eax, SIZE
        neg     eax
        mov     [esp][-4], eax
        sar     eax, letter_proportion_sl
    X:  shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        cmp     [esp][-4], eax
        dec     eax
        jc      X
        add     ecx, edx
        dec     ebx
        jnz     Y
        ret
    }
}


// "U" - 1 
__declspec(naked) void __fastcall
draw_U1(/* .  !! ^^ */)
{
    __asm
    {
        // x: size ... size/letter_proportion
        mov     ebx, SIZE
    Y:  mov     eax, SIZE
        mov     [esp][-4], eax
        shr     eax, letter_proportion_sl
    X:  shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        cmp     [esp][-4], eax
        lea     eax, [eax+1]
        ja      X
        add     ecx, edx
        dec     ebx
        jnz     Y
        ret
    }
}


// "R" - 4 
__declspec(naked) void __fastcall
draw_R4(/* .  !! ^^ */)
{
    __asm
    {
        // x: sqrt(size*size - y*y) ... sqrt(size*size/K - y*y)
        xor     ebx, ebx
    Y2: mov     ss:[esp][-4], ebx
        fild    dword ptr[esp][-4]
        fmul    st(0), st(0)
        fild    SIZE
        fmul    st(0), st(0)        
        fld     st(0)               // size*size
        fsub    st(0), st(2)
        fsqrt
        fistp   dword ptr[esp][-4]
        mov     eax, dword ptr[esp][-4]
        fmul    letter_proportion2
        fsubrp  st(1), st(0)
        fsqrt
        fistp   ss:dword ptr[esp][-4]
    X2: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        cmp     dword ptr[esp][-4], eax
        dec     eax
        jc      X2
        add     ebx, 1
        lea     eax, [ebx*letter_proportion]
        add     ecx, edx
        cmp     ss:SIZE, eax
        jnc     Y2

        // x: sqrt(size*size - y*y) ... 0
    Y1: fild    ss:SIZE
        fmul    st(0), st(0)
        mov     ss:[esp][-4], ebx
        fild    ss:dword ptr[esp][-4]
        fmul    st(0), st(0)
        fsubp   st(1), st(0)
        fsqrt
        fistp   ss:dword ptr[esp][-4]
        mov     eax, dword ptr[esp][-4]
        cmp     eax, ebx
        jc      X3
    X1: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        dec     eax
        jns     X1
        add     ecx, edx
        inc     ebx
        jmp     Y1

    Y3: mov     eax, ebx
    X3: shr     dword ptr[ecx+eax*4], 1
        or      dword ptr[ecx+eax*4], esi
        dec     eax
        jns     X3
        inc     ebx
        add     ecx, edx
        cmp     SIZE, ebx
        ja      Y3
        ret
    }
}

#undef  SIZE
#pragma optimize( "", on )

//=========================================================================//

// EOF
