/************************************************************************
 * 
 ************************************************************************
 */ 


//=========================================================================//
//  

void inline __fastcall
draw_alpha_rect(ARGB * memory, long pitch, unsigned width, unsigned height, ARGB color)
{
    const frame = 5;
    memory = (ARGB *)((char *)memory - frame*pitch);        
    //     .
    for( unsigned i = frame; i; i-- )
    {
        ARGB * p = memory + width + 2*frame;
        do  *(ARGB *)((char *)p - frame*sizeof(ARGB) + (height+frame)*pitch) = 
            (--p)[-frame] = color;
        while( p > memory );
        memory = (ARGB *)((char *)memory + pitch);        
    }
    do
    {   //     .
        ARGB * p = memory + frame;
        do  p[-frame] = (--p)[width] = color;
        while( p > memory );
        //  .
        unsigned    x = width;
        do  memory[--x] >>= 1;
        while( x );
        memory = (ARGB *)((char *)memory + pitch);
    }
    while( --height );
}


void inline __fastcall
draw_rect(ARGB * memory, long pitch, unsigned width, unsigned height, ARGB color)
{
    do
    {
        unsigned    x = width;
        do  //      
            // color     .
            memory[--x] += color;
        while( x );
        memory = (ARGB *)((char *)memory + pitch);
    }
    while( --height );
}


//=========================================================================//
// 

struct  Menu
{
    unsigned        x;              //  
    unsigned        y;              //   .   !
    ARGB            color;
    char          * text;
    unsigned        selected_item;
    unsigned        first_item;
    unsigned        last_item;
    struct  {
        void         (* handler)();        
        unsigned char   key[4];
    }               item[];
    
    static  void    select();
    static  void    next_item();
    static  void    previous_item();
};

//=========================================================================//

Menu  * menu;

void    Menu::select()
{
    menu->item[menu->selected_item-1].handler();
}

void    Menu::next_item()
{
    if( ++(menu->selected_item) > menu->last_item )
        menu->selected_item = menu->last_item;
}

void    Menu::previous_item()
{
    if( --(menu->selected_item) < menu->first_item )
        menu->selected_item = menu->first_item;
}

//=========================================================================//


void __fastcall
process_menu(ARGB * memory, long pitch)
{
    //  
    if( menu->selected_item )
        for( unsigned n = 0; ; n++ )
        {
            if( ! menu->item[n].handler )
                break;
            else
                for( unsigned k = 0; k < 4; k++ )
                    if( input_device::is_key_hit( menu->item[n].key[k]) )
                    {
                        menu->item[n].handler();
                        break;
                    }
        }
    else
        if( input_device::is_any_key_hit() )
            menu->item[0].handler();
    
    //   .
    unsigned    max_chars_in_line   = 0;
    unsigned    chars_in_line       = 0;
    unsigned    lines               = 1;
    char      * s                   = menu->text;
    while( true )
    {
        signed char c = *s++;
        if( c == '\n' || c == '\0' )
        {
            if( max_chars_in_line <= chars_in_line + 2)
                max_chars_in_line = chars_in_line + 2;  //    
            chars_in_line = 0;
            lines++;
            if( c == '\0' )
                break;
        }
        else
            if( c >= ' ' )
                chars_in_line++;
    }
    //    - draw_char     -
    //  :
    unsigned    char_height = (unsigned)font8x5::draw_char_X4H(0, 1, '\n', 0);
    //  :
    unsigned    char_width  = (unsigned)font8x5::draw_char_X4H(0, 0, ' ', 0);

    unsigned    half = max_chars_in_line * char_width / 2;  //  .
    ARGB  * p = (ARGB *)((char *)memory 
                - half + menu->y*pitch + sizeof(ARGB)*menu->x);

    draw_alpha_rect(
            p, 
            pitch, 
            half/(sizeof(ARGB)/2), 
            char_height * lines, 
            menu->color
            );
    p = (ARGB *)((char *)p + pitch*char_height/2);
    if( menu->selected_item )
    {
        signed char color_component = Frame_step >> 15;
        draw_rect(
            (ARGB *)((char *)p + (menu->selected_item-1) * char_height * pitch),
            pitch, 
            half/(sizeof(ARGB)/2), 
            char_height,
            0x10101*(color_component >= 0 ? color_component : ~color_component)
            );
    }
    draw_text(
            (ARGB *)((char *)p + char_width), 
            pitch, 
            menu->text, 
            menu->color
            );    
}

