/************************************************************************
 * 
 ************************************************************************
 */ 

#pragma once
//#pragma comment(lib,    "dinput.lib")

#ifndef DIRECTINPUT_VERSION
#define DIRECTINPUT_VERSION 0x0700
#include <dinput.h>
#endif

#ifndef DIDFT_OPTIONAL
#define DIDFT_OPTIONAL      0x80000000
#endif

#ifndef IMAGE_BASE
#define IMAGE_BASE          0x00400000
#endif


class   input_device
{
public:

int static inline
is_key_pressed(unsigned key)
{
    return key_state[key] < 0;
}

int static __fastcall
is_key_hit(unsigned key)
{
    char previous_state = ~key_state[key + number_of_keys];
    key_state[key + number_of_keys] = key_state[key];
    return (previous_state & key_state[key]) < 0;
}

int static inline
is_any_key_hit()
{
    unsigned char   i = 0;
    do
        if( int result = is_key_hit(i) )
            return result;
    while( (char)++i );// number_of_keys    
    return 0;
}

protected:

    enum    {   number_of_keys  = 0x100 };

           IDirectInput7A         * direct_input;
           IDirectInputDevice7A   * keyboard;
        
    static signed char              key_state[number_of_keys * 2];
    
    static DIDATAFORMAT             keyboard_format_descriptor;
    static DIOBJECTDATAFORMAT       key_data_format[number_of_keys];

int inline
initialize(HWND window_handle)   
{
    PRINTF("initializing DirectInput...\r\n");
    int(__stdcall * DirectInputCreateEx)(void *, int, REFIID, void **, void *)
        =(int(__stdcall *)(void *, int, REFIID, void **, void *))
        GetProcAddress(LoadLibraryA("dinput"),"DirectInputCreateEx");
    if( ! DirectInputCreateEx )
        panic("DirectX 7 or later not installed");
    //  DirectInput ,  ""  UnhandledExceptionFilter
    if( DirectInputCreateEx((HINSTANCE)IMAGE_BASE, DIRECTINPUT_VERSION,
                            IID_IDirectInput7A, (void **)&direct_input, 0) )
        panic("couldn't initialize DirectInput");
    if( direct_input->CreateDeviceEx(GUID_SysKeyboard, IID_IDirectInputDevice7A,
                            (void **)&keyboard, 0) )
        panic("couldn't initialize the keyboard");
    //  c_dfDIKeyboard
    unsigned i = 0;    do
    {
        key_data_format[i].pguid   = &GUID_Key;
        key_data_format[i].dwOfs   = i;
        key_data_format[i].dwType  = DIDFT_BUTTON | DIDFT_OPTIONAL;
        *((char *)&key_data_format[i].dwType+1) = (char)i;        
        key_data_format[i].dwFlags = 0;
    }
    while( (char)++i );// number_of_keys

    if( keyboard->SetDataFormat(&keyboard_format_descriptor) )
        panic("couldn't initialize the keyboard");
    else if( keyboard->SetCooperativeLevel(window_handle, 
                            DISCL_FOREGROUND | DISCL_EXCLUSIVE) )
        panic("couldn't set proper cooperative level");
    else
        PRINTF("Ok.\r\n");
    return keyboard->Acquire();
}

void inline
kill()
{
    if( keyboard )
    {
        keyboard->Unacquire();
        keyboard->Release();
    }
    if( direct_input )
        direct_input->Release();
    keyboard = 0;
    direct_input = 0;
}

void inline
get_state()
{
    if( keyboard->GetDeviceState(number_of_keys, key_state) )
        keyboard->Acquire();
}

};


signed char             input_device::key_state[];

DIOBJECTDATAFORMAT      input_device::key_data_format[];

DIDATAFORMAT            input_device::keyboard_format_descriptor =
{
    sizeof(DIDATAFORMAT),
    sizeof(DIOBJECTDATAFORMAT),
    DIDF_RELAXIS,
    number_of_keys,
    number_of_keys,
    key_data_format
};


// EOF
