/************************************************************************
 * 
 ************************************************************************
 */ 

#pragma once
#pragma comment(lib,    "gdi32.lib")

#include "window.cpp"


class   log_window :    public  window
{
    static HWND canvas;

public:

inline
log_window(const char * name, const int width, const int height,
            const int x = CW_USEDEFAULT, const int y = CW_USEDEFAULT)
        :   window()
{
//    !
    this->name          = name;
    this->width        |= width;
    this->height       |= height;
    this->x            |= x;
    this->y            |= y;
}

static void
printf(const char * format, ...);

protected:

virtual void
window_procedure(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    if(msg == WM_CREATE)
    {
        RECT    rectangle;

        GetClientRect(hWnd, &rectangle);
        canvas = CreateWindowExA(0, "EDIT", 0,
            WS_CHILD | ES_MULTILINE | ES_AUTOHSCROLL |
            ES_READONLY | WS_VSCROLL | WS_VISIBLE,
            0, 0, rectangle.right, rectangle.bottom,
            hWnd, 0, (HINSTANCE)IMAGE_BASE, 0);
        SendMessageA(canvas, EM_LIMITTEXT, 0, 0);
        SendMessageA(canvas, WM_SETFONT, 0, 0);
        printf("event log created\r\n");
    }
}

};


//=========================================================================//
//

HWND log_window::canvas;

#define PRINTF log_window::printf

void __cdecl log_window::printf(const char * format, ...)
{
    char buffer[1024];
    wvsprintfA(buffer
        #ifdef TIMEINFO
        + wsprintfA(buffer, "[ %010u mcs ]  ",get_time_from_start())
        #endif
        , format, (va_list)&format+sizeof(int));
    SendMessageA(canvas, EM_SETSEL, -2, -2);
    SendMessageA(canvas, EM_REPLACESEL, 0, (LPARAM)&buffer);
}


//=========================================================================//
//

int __declspec(naked) __stdcall
panic(const char * message)
{
    __asm push eax  //       
    log_window::printf("runtime error #%x at %#08x:\r\n %s\r\n");
    __asm pop eax
    __asm ret 4
}


// EOF
