/************************************************************************
 *
 * This will be a loderunner clone -
 * remake of BK0010 (PDP-11) version.
 *
 * coded by S.T.A.S.
 * mailto: s.t.a.s.rulez@gmail.com
 *
 ************************************************************************
 */ 

#define INITGUID
#define STRICT

#define APPLICATION_NAME "test"

//    
#define TIMEINFO 

//   TIMING_START / TIMING_END() 
//       .
#define NO_TIMING

#ifdef  _MSC_VER
#define inline __forceinline
#endif

#include <windows.h>

#define IMAGE_BASE  0x400000

#pragma comment(linker, "/base:0x400000")
#pragma comment(linker, "/subsystem:windows")
#pragma comment(linker, "/entry:start")
#pragma comment(linker, "/nodefaultlib:libc.lib")
#pragma comment(lib,    "kernel32.lib")
/**/
#pragma comment(linker, "/merge:.text=code")
#pragma comment(linker, "/merge:.bss=data?")
#pragma comment(linker, "/merge:.data=data")
#pragma comment(linker, "/merge:.rdata=data")
#pragma comment(linker, "/merge:.data1=data")
#pragma comment(linker, "/section:data,RW")
/**/
//#pragma optimize( "1b2giswy", on )
#pragma intrinsic( memset )


//#pragma warning(disable:592)
//#pragma warning(disable:170)


//=========================================================================//

//    -    
static  int                 Frame_step;

void    exit();

#include "lib.cpp"
#include "cpu.cpp"
#include "window.cpp"
#include "log_window.cpp"
#include "cps_player.cpp"
#include "keyboard.cpp"
#include "gfx_engine.cpp"
#include "user_interface.cpp"

static  user_interface    * main_window;
static  cps_player        * sound_system;

//=========================================================================//

long __stdcall 
filter(EXCEPTION_POINTERS *p)
{
    char            buffer[1024];
    //      (-128..127)    CONTEXT
    unsigned long * eax = &p->ContextRecord->Eax;
    #define REGISTER(X) (*(int *)((char *)eax + \
        (int)&p->ContextRecord->X - (int)&p->ContextRecord->Eax)) 
    wsprintfA(buffer,"\nexecution failure #%X at %08X:\n"
            "eax=%08X  ecx=%08X  edx=%08X  ebx=%08X\n"
            "esp=%08X  ebp=%08X  esi=%08X  edi=%08X\n",
            p->ExceptionRecord->ExceptionCode,
            p->ExceptionRecord->ExceptionAddress
                ? p->ExceptionRecord->ExceptionAddress
                : (void *)(REGISTER(Esp)),
            REGISTER(Eax), REGISTER(Ecx), REGISTER(Edx), REGISTER(Ebx),
            REGISTER(Esp), REGISTER(Ebp),  REGISTER(Esi), REGISTER(Edi));
    #undef REGISTER
    if( main_window )
    {
        ShowWindow(main_window->get_handle(), SW_HIDE);
        main_window->kill();
    }
    if( sound_system )
        sound_system->kill();
    ShowCursor(1);
    MessageBoxA(0, buffer, APPLICATION_NAME, MB_OK|MB_ICONERROR);
    return EXCEPTION_EXECUTE_HANDLER;//EXCEPTION_CONTINUE_SEARCH;//
}

int main()
{
    log_window      out(APPLICATION_NAME" log", 480, 480);
    user_interface  main(APPLICATION_NAME, 640, 480);
    main_window = &main;
    out.create(0, WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_VISIBLE, HWND_DESKTOP);

    char            vendor_string[4*4];
    GET_VENDOR_STRING(vendor_string);
    out.printf("CPU %s at %d MHz\r\n", vendor_string, determine_frequency());

    cps_player      music_player;
    sound_system = &music_player;

    main.create(0, WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_VISIBLE, HWND_DESKTOP);
    out.printf("main window created\r\n");

    music_player.initialize(main.get_handle(), THREAD_PRIORITY_TIME_CRITICAL);
    SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL);
    main.start_engine();

    main.message_loop();

    music_player.kill();
    main.kill();
    return 0;
}


__declspec(naked)
void    start()
{
    set_start_time();
    SetErrorMode(SEM_FAILCRITICALERRORS);
    SetUnhandledExceptionFilter(filter);
    //    ,       .
    zero_stack();
    main();
    ExitProcess(0);
}


void    exit()
{
    PostMessageA(main_window->get_handle(), WM_CLOSE, 0, 0);
}

// EOF
