/************************************************************************
 * 
 ************************************************************************
 */ 

#pragma once
#pragma comment(lib,    "user32.lib")

#ifndef IMAGE_BASE
#define IMAGE_BASE  0x400000
#endif


class   window
{
public:

inline
window(){}

inline
window(const char * name, const int width, const int height,
            const int x = CW_USEDEFAULT, const int y = CW_USEDEFAULT)
        :   name(name), width(width),height(height), x(x), y(y)
{}

void create(int extended_style, int style, HWND parent);

inline
int  message_loop()
{
    MSG msg;

    while( GetMessageA(&msg, 0, 0, 0) )
    {        
        TranslateMessage(&msg);
        DispatchMessageA(&msg);
    }
    return(msg.wParam);
}

inline
HWND get_handle()
{
    return handle;
}

protected:

    HWND                handle;
    int                 x, y, width, height;	
    const char        * name;

virtual void
window_procedure(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    if( msg == WM_DESTROY )
        PostQuitMessage(0);
}

static LRESULT __stdcall
dispatcher(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    if( msg == WM_NCCREATE )
    {
        ((window *)((CREATESTRUCTA *)lParam)->lpCreateParams)->handle = hWnd;

        SetWindowLongA(hWnd, GWL_USERDATA,
            (long)((CREATESTRUCTA *)lParam)->lpCreateParams);
    }
    else if(window * This = (window *)GetWindowLongA(hWnd, GWL_USERDATA))
        This->window_procedure(hWnd, msg, wParam, lParam);

    return DefWindowProcA(hWnd, msg, wParam, lParam);
}

static const char   class_name[];

};

//=========================================================================//

const char window::class_name[] = "AG7$wnd";

void        window::
create(int extended_style, int style, HWND parent)
{
    WNDCLASSEX	wnd_class;

    wnd_class.cbSize        = sizeof(wnd_class);
    wnd_class.style         = 0;
    wnd_class.lpfnWndProc   = window::dispatcher;
    wnd_class.cbClsExtra    = 0;
    wnd_class.cbWndExtra    = 0;
    wnd_class.hInstance     = (HINSTANCE)IMAGE_BASE;
    wnd_class.hIconSm       =
    wnd_class.hIcon         = LoadIconA(0, IDI_WINLOGO);
    wnd_class.hCursor       = LoadCursorA(0, IDC_ARROW);
    wnd_class.hbrBackground = 0;
    wnd_class.lpszMenuName  = 0;
    wnd_class.lpszClassName = class_name;
//	wnd_class.hIconSm       = LoadIconA(NULL, IDI_WINLOGO);

    RegisterClassExA(&wnd_class);
    CreateWindowExA(extended_style, class_name, name, style,
                    x, y, width, height, parent, 0,	// 
                    (HINSTANCE)IMAGE_BASE, this);
}


// EOF
